<template>
  <div class="top-products container mt-3">
    <div class="row">
      <card-loader :loopCount="4" :type="'products'" v-if="loading"/>
      <div v-if="page === 1" class="col-6 col-lg-3 col-sm-6 " v-for="(item, index) in sortedTopProducts(1)" :key="index">
        <card-template :item="item"/>
      </div>

      <div v-if="page === 2" class="col-6 col-lg-3 col-sm-6 " v-for="(item, index) in sortedTopProducts(2)" :key="index">
        <card-template :item="item"/>
      </div>

      <div v-if="page === 3" class="col-6 col-lg-3 col-sm-6 " v-for="(item, index) in sortedTopProducts(3)" :key="index">
        <card-template :item="item"/>
      </div>

      <span class="arrow arrow-right" @click="changePage('right')"></span>
      <span class="arrow arrow-left" @click="changePage('left')"></span>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import CardLoader from "../shared/CardLoader";
import CardTemplate from "../shared/CardTemplate";
export default {
  name: "TopProducts",
  components: { CardLoader, CardTemplate},
  data() {
    return {
      topProducts: [],
      loading: false,
      page: 1
    };
  },
  methods: {
    getTopProducts() {
      this.loading = true;
      axios
        .get(`${process.env.VUE_APP_BASE_URL}/products/top-product`)
        .then(response => {
          this.loading = false;
          this.topProducts = response.data;
        })
        .catch(error => {
          console.log(error);
        });
    },
    sortedTopProducts(page) {
      let firstInd = 0;

      if (page === 2) {
        firstInd = 3;
      } else if (page === 3) {
        firstInd = 7;
      }
      return this.topProducts.filter((pr, ind, arr) => {
        if (ind >= firstInd && ind < (firstInd + 4)) return true;
      });
    },
    changePage(direction) {
      let pageNum;
      if (direction === 'right') {
        pageNum = this.page + 1; 
        this.page = (pageNum < 4) ? pageNum : 1; 
      } else {
        pageNum = this.page - 1; 
        this.page = (pageNum > 0) ? pageNum : 3; 
      }
    }
  },
  created() {
    this.getTopProducts();
  }
};
</script>

<style lang="scss">
.top-products {
  position: relative;
}

.arrow {
  position: absolute;
  display: block;
  height: 44px;
  width: 42px;
  background-position: center;
  background-repeat: no-repeat;
  top: 35%;

}
.arrow-right {
  background-image: url('../../assets/right-arrow.svg');
  right: -30px;
}

.arrow-left {
  background-image: url('../../assets/left-arrow.svg');
  left: -30px;
}

@media (max-width: 992px) and (min-width: 768px) {
  .top-products {
    max-width: 540px !important;
  }
}

@media (max-width: 576px) {
  .cardTemplate {
    width: 245px;
    margin: 0 auto;
  }
  .arrow {
    display: none;
  }
}


</style>
